program makemirror;
type
  pmirror = ^tmirror;
  tmirror = record
    linkprefix : string[128];
    linkname   : string[40];
    next : pmirror;
  end;

var
  mirrors : pmirror;
  mirrorscnt : longint;

procedure readmirrors(const fn:string);
var
  i : longint;
  last : pmirror;
  t : text;
  s : string;
begin
  mirrorscnt:=0;
  mirrors:=nil;
  assign(t,fn);
  {$I-}
   reset(t);
  {$I+}
  if ioresult<>0 then
   begin
     writeln('File not found: ',fn);
     halt(1);
   end;
  last:=nil;
  while not eof(t) do
   begin
     readln(t,s);
     if (s<>'') and not(s[1] in ['#',';']) then
      begin
        if mirrors=nil then
         begin
           new(mirrors);
           last:=mirrors;
         end
        else
         begin
           new(last^.next);
           last:=last^.next;
         end;
        last^.next:=nil;
        i:=pos(' ',s);
        last^.linkprefix:=copy(s,1,i-1);
        if last^.linkprefix[length(last^.linkprefix)]='/' then
         Delete(last^.linkprefix,length(last^.linkprefix),1);
        last^.linkname:=copy(s,i+1,length(s)-i);
        inc(mirrorscnt);
      end;
   end;
  close(t);
end;


procedure processfp(const fn,fn2:string);
var
  skip : boolean;
  t,f : text;
  hs,orgs,s : string;
  hp : pmirror;
  cntidx,
  linkidx,nameidx : longint;
begin
  assign(t,fn);
  {$I-}
   reset(t);
  {$I+}
  if ioresult<>0 then
   begin
     writeln('File not found: ',fn);
     halt(1);
   end;
  assign(f,fn2);
  rewrite(f);
  while not eof(t) do
   begin
     skip:=false;
     readln(t,s);
     orgs:=s;
     if (pos('$MIRRORLINK',s)>0) or (pos('$MIRRORNAME',s)>0) then
      begin
        hp:=mirrors;
        while assigned(hp) do
         begin
           s:=orgs;
           linkidx:=pos('$MIRRORLINK',s);
           if (linkidx>0) then
            begin
              Delete(s,linkidx,11);
              Insert(hp^.linkprefix,s,linkidx);
            end;
           nameidx:=pos('$MIRRORNAME',s);
           if (nameidx>0) then
            begin
              Delete(s,nameidx,11);
              Insert(hp^.linkname,s,nameidx);
            end;
           writeln(f,s);
           hp:=hp^.next;
         end;
        skip:=true;
      end;
     cntidx:=pos('$MIRRORCNT',s);
     if (cntidx>0) then
      begin
        Delete(s,cntidx,10);
        str(mirrorscnt,hs);
        Insert(hs,s,cntidx);
      end;
     if not skip then
      writeln(f,s);
   end;
  close(t);
  close(f);
end;

begin
  if paramcount<3 then
   begin
     writeln('usage: makemirrors <mirrorfile> <infile> <outfile>');
     halt(1);
   end;
  readmirrors(paramstr(1));
  processfp(paramstr(2),paramstr(3));
end.
