<HTML>
<!--
#TITLE Free Pascal - Packages
#ENTRY prog
#SUBENTRY packages
#SUBSUBENTRY gtk
#MAINDIR ..
#HEADGIF NotYetHere
#HEADALT Under Construction
-->
<H1>Free Pascal interface to GDK/GTK</H1>
<HR>

<H2>Introduction</H2>
The GTK toolkit is quickly becoming (next to the Qt toolkit) a very popular
X-windows programming toolkit. This makes it suitable as a base for the Free
Component Library (FCL, the Free Pascal equivalent of the Delphi VCL). As a first
step in the development of FCL, the gtk and gdk header files have been
translated to Pascal. All header files have been translated, and are
compilable. only a few testprograms are available (volunteers to make some are
welcome to contact me), but success reports indicate that the units are translated 
correctly, and programs can be made. It even works on Win32. For this
reason, both the Lazarus and KCL projects use GTK as a GUI toolkit.

<H2>Downloading</H2>

The gtk units are part of the Free Pascal packages, and are shipped with
the official distrubution. You can download the sources separately 
<A HREF="ftp://ftp.freepascal.org/pub/fpc/source/packages.zip">here</A>. 

<H2>Using the units:</H2>
<OL>
<LI> In C, you only need to input gtk.h. Here you need to put gtk, and
separately glib or gdk if you need them, in your uses clause.

<LI> <B>Names :</B><BR>
<UL>
<LI> Pascal reserved words in types, record element names etc. have been
     prepended with the word 'the'. so 'label' has become 'thelabel'
<LI> functions have been kept with the same names.
<LI> for types : gdk names have been kept. Pointers to a type are defined
     as the type name, prepended with P. So 'GtkWidget *' becomes
     'PGtkWidget'.
     In gtkobject, names also have been kept.
     In all other files, types have been prepended with T, that is, the C
     type 'GtkWidget' has become 'TGtkWidget'<P>
     
     This is annoying, but C is case sensitive, and Pascal is not, so
     there you have it...<P>
     
     When translating, I've tried to stick to this scheme as closely as I
     could. One day, however, all will be done in a uniform manner...
</UL>
<LI> Macros. Many C macros have not been translated. The typecasting macros 
   have been dropped, since they're useless under pascal.
   Macros to access record members have been translated, BUT they are 
   to be considered as READ-ONLY. So they can be used to retrieve a value,
   but not to store one.
   e.g.
   <PRE>
      function GTK_WIDGET_FLAGS(wid : pgtkwidget) : longint;
   </PRE>
   can be used to retrieve the widget flags, but not to set them.
   so things like 
   <PRE>
     GTK_WIDGET_FLAGS(wid):=GTK_WIDGET_FLAGS(wid) and someflag;
   </PRE>
   will not work, since this is a function, and NOT a macro as in C.
  
<LI> Packed records. GCC allows you to specify members of a record in
   bit format. Since this is impossible in pascal, functions and procedures
   to get/set these elements have been made.
   e.g.
     <PRE>
     function width_set(var a : TGtkCListColumn) : gint;
     procedure set_width_set(var a : TGtkCListColumn; __width_set : gint);
     </PRE>
   can be used to get or set the width in a TGtkCListColumn...
   in general, it's the name with '_set' appended for getting a value
   (set from 'a set') , and  'set_' prepended (from 'to set') and again
   '_set' appended.
   
</OL>
<P>
<A HREF="packages.html">Back</A> to packages page.
<HR>
</HTML>